#include "marche.hpp"
#include <iostream>


int main(void)
{
  std::mt19937 gen(4378); // On initialise un générateur de nombres aléatoires, qui sera fourni en argument de toute fonction utilisant de l'aléa.

  int N=10; // La taille du domaine

  
  marche X(N);
  // On réalise 100000 sorties du domaine {-N+1,...,N-1}^2.
  for (int i=0;i<100000;i++)
	{
	  X.sortie(gen); // On simule la trajectoire...
	  X.ajoute_histo(); // ... on ajoute le point de sortie à l'histogramme...
	  X.r_a_z(); // ... et on recommence.
	}

  // On affiche le résultat trouvé.
  std::cout << "Histogramme du temps de sortie de {" << -N+1 << ",...," << N-1 << "}^2\n";
  std::cout << "Sortie en i signifie que l'on sort en (+-" << N-1 << ",+-i) ou en (+-i,+-" << N-1 << ")\n";
  
  for (int i=0;i<N;i++)
	std::cout << i << " : " << X.hist()[i].size() << "\n";


  std::cout << "\n";
  
  std::cout << "Temps moyen de sortie sachant le point de sortie\n";
  for (int i=0;i<N;i++)
	{
	  // On fait la moyenne Monte Carlo du tableau histo[i].
	  double moy = 0;
	  // On parours histo[i] à l'aide d'un itérateur.
	  for (std::vector<int>::const_iterator It = X.hist()[i].begin() ; It!=X.hist()[i].end();It++)
		moy += double(*It) / X.hist()[i].size();
	  std::cout << i << " : " << moy << "\n";
	}
  
  return 0;

}
